program ScrnSaveLoad ;
   {from PcMagazine April 15, 1986 page 275.  Method of simulating the
    BASICA Bsave and BLoad commands.
    Requires:   Turbo Pascal v2.0 or higher  MS-PC DOS version only
                Color graphics screen
   }
type   Str255 = string[255];

var    Ch: char;
       I : Integer;

{$I circle.prc}

procedure ScrnSave (FName: Str255; Length: Integer);

   var Buffer : Byte Absolute $B800:$0000;
       FileVar: File;

Begin

      assign(filevar,fname);
      rewrite(filevar);
      blockwrite(filevar,buffer,length div 128);
      close(filevar);

end; { procedure ScrnSave (FName: Str255; Length: Integer) }

procedure ScrnLoad (FName: Str255; Length: Integer);

   var Buffer : Byte absolute $B800:$0000;
       FileVar: File;

begin

   assign(filevar,fname);
   reset(filevar);
   blockread(filevar,buffer,length div 128);
   close(filevar);

end; { procedure ScrnLoad(Fname:Str255; Length:Integer) }

begin  {main}
   graphcolormode;
   for i:=19 downto 1 do
      circle(160,100,5*i,1+i mod 3);
   scrnsave ('screen.dat',16000);
   repeat until keypressed;  read(kbd,ch);
   graphcolormode;
   scrnload('screen.dat',16000);
   repeat until keypressed; read(kbd,ch);
   textmode (c80);
end.